import { type Constraint, type NodeSchema } from "@ark/schema";
import type { Module, Submodule } from "../../module.ts";
import type { AtLeast, AtMost, Branded, constrain, Constraints, DivisibleBy, LessThan, MoreThan, Narrowed, normalizePrimitiveConstraintRoot } from "../ast.ts";
import { epoch } from "./epoch.ts";
import { integer } from "./integer.ts";
export declare const number: number.module;
export declare namespace number {
    type atLeast<rule> = constrain<number, AtLeast<rule>>;
    type moreThan<rule> = constrain<number, MoreThan<rule>>;
    type atMost<rule> = constrain<number, AtMost<rule>>;
    type lessThan<rule> = constrain<number, LessThan<rule>>;
    type divisibleBy<rule> = constrain<number, DivisibleBy<rule>>;
    type narrowed = constrain<number, Narrowed>;
    type branded<rule> = constrain<number, Branded<rule>>;
    type is<constraints extends Constraints> = constrain<number, constraints>;
    type parseConstraint<kind extends Constraint.PrimitiveKind, schema extends NodeSchema<kind>> = normalizePrimitiveConstraintRoot<schema> extends infer rule ? kind extends "min" ? schema extends {
        exclusive: true;
    } ? moreThan<rule> : atLeast<rule> : kind extends "max" ? schema extends {
        exclusive: true;
    } ? lessThan<rule> : atMost<rule> : kind extends "divisor" ? divisibleBy<rule> : narrowed : never;
    type module = Module<submodule>;
    type submodule = Submodule<$>;
    type $ = {
        $root: number;
        epoch: epoch;
        integer: integer;
    };
}
