import { intrinsic, rootNode } from "@ark/schema";
import { wellFormedNumberMatcher } from "@ark/util";
import { submodule } from "../utils.js";
import { regexStringNode } from "./utils.js";
const $root = regexStringNode(wellFormedNumberMatcher, "a well-formed numeric string");
export const numeric = submodule({
    $root,
    parse: rootNode({
        in: $root,
        morphs: (s) => Number.parseFloat(s),
        declaredOut: intrinsic.number
    })
});
