import { rootNode } from "@ark/schema";
import { submodule } from "../utils.js";
const isParsableUrl = (s) => {
    if (URL.canParse)
        return URL.canParse(s);
    // Can be removed once Node 18 is EOL
    try {
        new URL(s);
        return true;
    }
    catch {
        return false;
    }
};
const $root = rootNode({
    domain: "string",
    predicate: {
        meta: "a URL string",
        predicate: isParsableUrl
    }
});
export const url = submodule({
    $root,
    parse: rootNode({
        declaredIn: $root,
        in: "string",
        morphs: (s, ctx) => {
            try {
                return new URL(s);
            }
            catch {
                return ctx.error("a URL string");
            }
        },
        declaredOut: rootNode(URL)
    })
});
